package de.starzi.graphics.textures;

import org.lwjgl.opengl.GL11;
import org.lwjgl.opengl.GL12;

import de.starzi.graphics.opengl.GLEnum;

/**
 * An Image Format describes the way that the images in Textures and renderbuffers store their data. They define the meaning of the image's data.
 * 
 * source: https://www.opengl.org/wiki/Image_Formats
 * 
 * @author Nic Starzi
 * @date 30.12.2013
 *
 */
public enum TexelFormat implements GLEnum {
	
	RED(GL11.GL_RED, 1),
//	RG(GL11.GL_RED, 1),
	RGB(GL11.GL_RGB, 3),
	RGBA(GL11.GL_RGBA, 4),
	BGR(GL12.GL_BGR, 3),
	BGRA(GL12.GL_BGRA, 4),
//	RED_INTEGER(GL12.gl_RED, 1),
//	RG_INTEGER(GL11.GL_RED, 1),
//	RGB_INTEGER(GL11.GL_RED, 1),
//	RGBA_INTEGER(GL11.GL_RED, 1),
//	BGR_INTEGER(GL11.GL_RED, 1),
//	BGRA_INTEGER(GL11.GL_RED, 1),
//	STENCIL_INDEX(GL11.GL_RED, 1),
//	DEPTH_COMPONENT(GL11.GL_RED, 1),
//	DEPTH_STENCIL(GL11.GL_RED, 1),
	;
	
	private final int glEnum;
	private final int byteSize;
	
	private TexelFormat(int glEnum, int byteSize) {
		this.glEnum = glEnum;
		this.byteSize = byteSize;
	}
	
	public int get_glEnum() {
		return glEnum;
	}
	
	public int get_byteSize() {
		return byteSize;
	}
	
}