package de.starzi.graphics.textures;

import org.lwjgl.opengl.*;

import de.starzi.graphics.opengl.GLEnum;

/**
 * This enum is used when transfering texels from an image loaded from disk to the GPU.
 * 
 * @author Nic Starzi
 * @date 05.01.2014
 *
 */
public enum TexelInternalFormat implements GLEnum {
	
	R8					(GL30.GL_R8),
	R8_SNORM			(GL31.GL_R8_SNORM),
	R16					(GL30.GL_R16),
	R16_SNORM			(GL31.GL_R16_SNORM),
	RG8					(GL30.GL_RG8),
	RG8_SNORM			(GL31.GL_RG8_SNORM),
	R3_G3_B3			(GL11.GL_R3_G3_B2),
	RGB4				(GL11.GL_RGB4),
	RGB5				(GL11.GL_RGB5),
	RGB8				(GL11.GL_RGB8),
	RGB8_SNORM			(GL31.GL_RGB8_SNORM),
	RGB10				(GL11.GL_RGB10),
	RGB12				(GL11.GL_RGB12),
	RGB16_SNORM			(GL31.GL_RGB16_SNORM),
	RGBA2				(GL11.GL_RGBA2),
	RGBA4				(GL11.GL_RGBA4),
	RGB5_A1				(GL11.GL_RGB5_A1),
	RGBA8				(GL11.GL_RGBA8),
	RGBA8_SNORM			(GL31.GL_RGBA8_SNORM),
	RGB10_A2			(GL11.GL_RGB10_A2),
	RGB10_A2UI			(GL33.GL_RGB10_A2UI),
	RGBA12				(GL11.GL_RGBA12),
	RGBA16				(GL11.GL_RGBA16),
	
//	SRGB8,
//	SRGB8_ALPHA8,
	
//	R16F,
//	RG16F,
//	RGB16F,
//	RGBA16F,
//	R32F,
//	RG32F,
//	RGB32F,
//	RGBA32F,
//	R11F_G11F_B10F,
	
//	RGB9_E5,
	
//	R8I,
//	R8UI,
//	R16I,
//	R16UI,
//	R32I,
//	R32UI,
//	
//	RG8I,
//	RG8UI,
//	RG16I,
//	RG16UI,
//	RG32I,
//	RG32UI,
//	
//	RGB8I,
//	RGB8UI,
//	RGB16I,
//	RGB16UI,
//	RGB32I,
//	RGB32UI,
//	
//	RGBA8I,
//	RGBA8UI,
//	RGBA16I,
//	RGBA16UI,
//	RGBA32I,
//	RGBA32UI,
	
//	COMPRESSED_RED,
//	COMPRESSED_RG,
//	COMPRESSED_RGB,
//	COMPRESSED_RGBA,
//	COMPRESSED_SRGB,
//	COMPRESSED_SRGB_ALPHA,
//	COMPRESSED_RED_RGTC1,
//	COMPRESSED_SIGNED_RED_RGTC1,
//	COMPRESSED_RG_RGTC2,
//	COMPRESSED_SIGNED_RG_RGTC2,
//	COMPRESSED_RGBA_BPTC_UNORM,
//	COMPRESSED_SRGB_ALPHA_BPTC_UNORM,
//	COMPRESSED_RGB_BPTC_SIGNED_FLOAT,
//	COMPRESSED_RGB_BPTC_UNSIGNED_FLOAT,
	;
	
	private final int glEnum;
	
	private TexelInternalFormat(int glEnum) {
		this.glEnum = glEnum;
	}
	
	public int get_glEnum() {
		return glEnum;
	}
	
}